=== debian/changelog ===
monado (25.0.0+dfsg-2) unstable; urgency=medium

  * Add d/patches/0003-cmake-Check-for-and-use-latomic-if-needed.patch:
    Fix build on armel and other platforms that need -latomic.

 -- Rylie Pavlik <rylie@ryliepavlik.com>  Thu, 24 Apr 2025 17:45:43 -0500

monado (25.0.0+dfsg-1) unstable; urgency=medium

  [ Rylie Pavlik ]
  * New upstream version 25.0.0+dfsg
  * d/README.source: update
  * d/clean
    - Add pycache file. Closes: #1045917
    - Clean the imgui.ini file more idiomatically
  * d/control:
    - Update VCS links
    - Replace obsolete Build-Depends name
    - Bump to debhelper-compat (= 13)
    - Update text about OpenXR
    - Bump Standards-Version to 4.7.2, no changes required.
  * d/copyright: Update, modify Files-Excluded
  * d/patches:
    - Rediff
    - Drop d/patches/0002-Do-not-install-a-test-binary.patch:
      incorporated upstream
    - Add d/patches/0002-Make-libmonado-configurable-separately.patch:
      Allow us to disable libmonado for now.
  * d/rules:
    - Disable libmonado
    - Remove relative path from manifest to make it multi-arch.
      Closes: #1101455
    - Fix configured-in version stamp
    - Use $(DEB_SOURCE) appropriately
  * d/source/lintian-overrides: Suppress false positive
  * d/upstream/metadata: Update
  * d/watch: Fix, set repack suffix to +dfsg
  * Update appstream metadata, including to reflect expanded hardware support.
  * Update various files from CI version of package.
  * Update salsa-ci.
  * Fix name

  [ Andrew Lee (李健秋) ]
  * Drop myself from uploaders.

 -- Rylie Pavlik <rylie@ryliepavlik.com>  Wed, 23 Apr 2025 17:43:28 -0500
