=== debian/tests/control ===
Tests: cli-probe, cli-test
Restrictions: allow-stderr,superficial
Depends: monado-cli
