=== debian/watch ===
version=4
opts="\
  compression=xz, \
  repacksuffix=+dfsg, \
  dversionmangle=auto, \
  downloadurlmangle=s%tags/v@ANY_VERSION@%archive/v$1/@PACKAGE@-v$1.tar.gz%g, \
  filenamemangle=s%.*/tags/v@ANY_VERSION@%@PACKAGE@-$1.tar.gz%g" \
    https://gitlab.freedesktop.org/monado/monado/-/tags?sort=updated_desc \
    .*/-/tags/v@ANY_VERSION@
